
.686
.MMX
.MODEL flat, stdcall
OPTION casemap:none

; --------------- TEXTEQU's --------------- ;


; --------------- Includes --------------- ;

INCLUDE <\masm32\include\windows.inc>
INCLUDE <\masm32\include\user32.inc>
INCLUDE <\masm32\include\kernel32.inc>
INCLUDE <\masm32\include\gdi32.inc>
INCLUDE <\masm32\include\Masm32.inc>
INCLUDE <\masm32\include\gdip.inc>
INCLUDE <\masm32\include\gdiplus.inc>


INCLUDE	<\masm32\macros\ucmacros.asm>
INCLUDE	<\masm32\macros\macros.asm>

; --------------- Libraries --------------- ;

INCLUDELIB <\masm32\lib\Gdi32.lib>
INCLUDELIB <\masm32\lib\gdiplus.lib>
INCLUDELIB <\masm32\lib\kernel32.lib>
INCLUDELIB <\masm32\lib\user32.lib>
INCLUDELIB <\masm32\lib\gdi32.lib>
INCLUDELIB <\masm32\lib\Masm32.lib>

; --------------- Constants --------------- ;

.CONST

	SCREEN_WIDTH		EQU 1920	; Screen resolution width
	SCREEN_HEIGHT		EQU 1200	; Screen resolution height
	PIXEL_COUNT		EQU 150000	; Amount of pixels on screen
	THREAD_TIMEOUT_DELAY	 = 1500		; Graceful closure delay
	
; --------------- Macros --------------- ;

ClrDib MACRO BitDataPtr:REQ, Farge:REQ, FreeReg:REQ
	mov FreeReg, edi
	mov ecx, SCREEN_WIDTH*SCREEN_HEIGHT
	mov eax, Farge
	mov edi, BitDataPtr
	rep stosd
	mov edi, FreeReg
ENDM

; --------------- Structures --------------- ;


; --------------- Protos --------------- ;

WinMain				PROTO

CreateCompatibleDibSection	PROTO :DWORD,:DWORD ; dc,ppvBits,dibhandle
PlotPixel			PROTO :DWORD,:DWORD,:DWORD
PlotPixelR			PROTO :DWORD
PlotPixelRA			PROTO
HorLine				PROTO :DWORD,:DWORD,:DWORD,:DWORD
FillRectangle			PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

DrawRandomPixels		PROTO :DWORD
PixelThread			PROTO :DWORD

; --------------- ??DATA?? --------------- ;

.DATA?

	ALIGN 4
	memDC			HDC ?
	OldObject		HGDIOBJ ?
	ThreadHandle		HANDLE ?
	
	bitdataptr		DWORD ?
	dibhandle		DWORD ?

	RenderCritical		CRITICAL_SECTION <>
	
; --------------- DATA --------------- ;
	
.DATA

	ALIGN 4
	GracefulTermination	DD 0
	ClassName		DB "DIB",0
	GlobRect		RECT <0,0>
